C
C  UCD BINARY FORMAT SAMPLE
C
C   UCD oCif[^쐬邽߂̃TvvOłB
C   lp`Zitype=3jP쐬܂B
C
C      4(0,1,0)     3(1,1,0)
C       +-----------+
C       |           |
C       |           |
C       |           |
C       +-----------+
C      1(0,0,0)     2(1,0,0)
C
C
C   Fquad.dat t@C쐬܂B
C       ̃t@Cw肷邽߂ .inp t@CiRg[t@Cj
C       ʓrKvłiQlFquad.inpjB
C
C   FWindows  Fortran 𗘗pꍇAMicroAVS ł fl32 
C       RpCNꂽoCitH[}bg̓T|[gĂ܂B
C       f77/f90 ŃRpCNĂB
C
C
C Wlf[^̏o̓^Cv
C    Wl̏o̓^Cvɂ 1  2
C    f[^̏o̓^Cvɂ 1  2  3  4    ܂B
	DATA I_COORD_FORMAT/1/
	DATA I_NODEDATA_FORMAT/1/
	DATA I_CELLDATA_FORMAT/1/
C
C ۂ̃f[^̃m[hZɉăf[^ĂB
	INTEGER ID_NODE(4) 
	INTEGER ID_CELL(1) 
	INTEGER ID_MAT(1)
	INTEGER ICELL_TYPE(1)
	INTEGER ICELL_CONNECTIVITY(4)
	REAL XYZ(3,4)
	REAL NODE_DATA(3,4)
	REAL CELL_DATA(1)
C
	CHARACTER KEYWORD*7
	CHARACTER TITLE*70
	REAL VERSION
	INTEGER STEPNO
	REAL TIMEVAL
C
	INTEGER NUM_NODE, NUM_CELL
	INTEGER NUM_NODEDATA, NUM_NODEVECLEN
	INTEGER NUM_CELLDATA, NUM_CELLVECLEN
	INTEGER NUM_ACTIVEDATA
	INTEGER NULL_FLAG
	REAL NULL_VALUE
C
	CHARACTER NODEDATA_LABEL*16
	CHARACTER NODEDATA_UNIT*16
C
	CHARACTER TMP*2

C f[^t@C̍쐬
	OPEN(10, FILE='quad.dat', FORM='unformatted')
	write(6,*) 'Open output file: quad.dat'

C wb_[
	KEYWORD = 'AVS UCD'
	VERSION = 1.0
	TITLE = 'ucd binary test data'
	STEPNO = 1
	TIMEVAL = 1.0
	WRITE(10) KEYWORD
	WRITE(10) VERSION
	WRITE(10) TITLE
	WRITE(10) STEPNO
	WRITE(10) TIMEVAL
	write(6,*) 'End information part.'

C ߓ_
	ID_NODE(1) = 1
	ID_NODE(2) = 2
	ID_NODE(3) = 3
	ID_NODE(4) = 4
	XYZ(1,1) = 0.0
	XYZ(2,1) = 0.0
	XYZ(3,1) = 0.0
	XYZ(1,2) = 1.0
	XYZ(2,2) = 0.0
	XYZ(3,2) = 0.0
	XYZ(1,3) = 1.0
	XYZ(2,3) = 1.0
	XYZ(3,3) = 0.0
	XYZ(1,4) = 0.0
	XYZ(2,4) = 1.0
	XYZ(3,4) = 0.0
C
	NUM_NODE = 4
	WRITE(10) NUM_NODE
	WRITE(10) I_COORD_FORMAT
	IF(I_COORD_FORMAT.EQ.1) THEN
	   DO J = 1, 4
	      WRITE(10) ID_NODE(J), (XYZ(I,J),I=1,3)
	   ENDDO
	ELSE IF(I_COORD_FORMAT.EQ.2) THEN
	   WRITE(10) (ID_NODE(J), J = 1,4)
	   WRITE(10) (XYZ(1,J), J = 1,4)
	   WRITE(10) (XYZ(2,J), J = 1,4)
	   WRITE(10) (XYZ(3,J), J = 1,4)
	ENDIF
	write(6,*) 'End node xyz part.'
C	
C vf
	ID_CELL(1) = 1
C FMicroAVS ł̓}eAiޗjID ͕KPɂĉB
	ID_MAT(1) = 1
	ICELL_TYPE(1) = 3
	ICELL_CONNECTIVITY(1) = 1
	ICELL_CONNECTIVITY(2) = 2
	ICELL_CONNECTIVITY(3) = 3
	ICELL_CONNECTIVITY(4) = 4
C
	NUM_CELL = 1
	WRITE(10) NUM_CELL
	WRITE(10) (ID_CELL(I), I=1, NUM_CELL)
	WRITE(10) (ID_MAT(I), I=1, NUM_CELL)
C FZ^Cv char ^łB
	WRITE(10) (CHAR(ICELL_TYPE(I)), I=1, NUM_CELL)
	WRITE(10) (ICELL_CONNECTIVITY(I), I = 1, 4)
	write(6,*) 'End cell connectivity part.'

C m[hf[^
C R̃f[^ݒ肵Ă܂B
	NODE_DATA(1,1) = 1.0
	NODE_DATA(2,1) = 10.0
	NODE_DATA(3,1) = 100.0
	NODE_DATA(1,2) = 2.0
	NODE_DATA(2,2) = 20.0
	NODE_DATA(3,2) = 200.0
	NODE_DATA(1,3) = 3.0
	NODE_DATA(2,3) = 30.0
	NODE_DATA(3,3) = 300.0
	NODE_DATA(1,4) = 4.0
	NODE_DATA(2,4) = 40.0
	NODE_DATA(3,4) = 400.0
C
	NUM_NODEDATA = 3
	WRITE(10) NUM_NODEDATA
	WRITE(10) I_NODEDATA_FORMAT
	IF(I_NODEDATA_FORMAT.EQ.1) THEN
	   DO I = 1, NUM_NODEDATA
	      WRITE(TMP, '(I2)') I
	      NODEDATA_LABEL = 'xxxx'//TMP
	      NODEDATA_UNIT = 'm/s'
C FMicroAVS ł̓xNgiNUM_NODEVECLENj͕KPɂĉB
	      NUM_NODEVECLEN = 1
	      NULL_FLAG = 0
	      NULL_VALUE = -999.999
	      WRITE(10) NODEDATA_LABEL, NODEDATA_UNIT, NUM_NODEVECLEN,
     * NULL_FLAG, NULL_VALUE
	   ENDDO
	   DO J = 1, NUM_NODE
	      WRITE(10) (NODE_DATA(I,J), I = 1, NUM_NODEDATA*NUM_NODEVECLEN)
	   ENDDO
	ELSE IF(I_NODEDATA_FORMAT.EQ.2) THEN
	   DO I = 1, NUM_NODEDATA
	      WRITE(TMP, '(I2)') I
	      NODEDATA_LABEL = 'xxxx'//TMP
	      NODEDATA_UNIT = 'm/s'
	      NUM_NODEVECLEN = 1
	      NULL_FLAG = 0
	      NULL_VALUE = -999.999
	      WRITE(10) NODEDATA_LABEL, NODEDATA_UNIT, NUM_NODEVECLEN,
     * NULL_FLAG, NULL_VALUE
	   ENDDO
	   DO I = 1, NUM_NODEDATA*NUM_NODEVECLEN
	      WRITE(10) (NODE_DATA(I,J), J = 1, NUM_NODE)
	   ENDDO
	ELSE IF(I_NODEDATA_FORMAT.EQ.3) THEN
	   DO I = 1, NUM_NODEDATA
	      WRITE(TMP, '(I2)') I
	      NODEDATA_LABEL = 'xxxx'//TMP
	      NODEDATA_UNIT = 'm/s'
	      NUM_NODEVECLEN = 1
	      WRITE(10) NODEDATA_LABEL, NODEDATA_UNIT, NUM_NODEVECLEN
	   ENDDO
	   DO I = 1, NUM_NODEDATA
C FNULL ȊÕf[^ߓ_̃f[^`ł܂B
C    ĩTvł͖gpj
	      NUM_ACTIVEDATA = 4
	      WRITE(10) NUM_ACTIVEDATA
	      DO J = 1, NUM_ACTIVEDATA
	         WRITE(10) ID_NODE(J), NODE_DATA(I,J)
	         WRITE(6,*) ID_NODE(J), NODE_DATA(I,J)
	      ENDDO
           ENDDO
	ELSE IF(I_NODEDATA_FORMAT.EQ.4) THEN
	   DO I = 1, NUM_NODEDATA
	      WRITE(TMP, '(I2)') I
	      NODEDATA_LABEL = 'xxxx'//TMP
	      NODEDATA_UNIT = 'm/s'
	      NUM_NODEVECLEN = 1
	      WRITE(10) NODEDATA_LABEL, NODEDATA_UNIT, NUM_NODEVECLEN
	   ENDDO
	   DO I = 1, NUM_NODEDATA
	      NUM_ACTIVEDATA = 4
	      WRITE(10) NUM_ACTIVEDATA
	      WRITE(10) (ID_NODE(J), J=1, NUM_ACTIVEDATA)
	      WRITE(10) (NODE_DATA(I,J), J=1, NUM_ACTIVEDATA)
           ENDDO
	ENDIF
	write(6,*) 'End node data part.'

C Zf[^
C ̃Tvł͐ݒ肵Ă܂B
C Zf[^ꍇm[hf[^ƓtH[}bgŎw肵܂B
C AZ̐̃f[^`܂B
	NUM_CELLDATA = 0
	WRITE(10) NUM_CELLDATA
	write(6,*) 'End cell data part.'
C
C
	CLOSE(10)
	END


